#ifndef _juice_configure_h

#define _juice_configure_h

#include "../generic.h"

extern double schemaBottleTaskTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaBottleTaskTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaBottleTaskTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaBottleTaskTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaBottleTaskTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaOpenBottleTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaOpenBottleTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaOpenBottleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFillGlassTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaFillGlassTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaFillGlassTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaSealBottleTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaSealBottleTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaSealBottleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPourIntoTargetTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPourIntoTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPourIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaDrinkFromGlassTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaDrinkFromGlassTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaUncorkBottleTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaUncorkBottleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCorkBottleTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaCorkBottleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaDrinkTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaDrinkTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPourSomeTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPourSomeTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPourSomeTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaUncorkTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaUncorkTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaUncorkTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaRecorkTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaRecorkTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaRecorkTriggersEffector(ContentionScheduler *cs, Effector *e);

/******************************************************************************/
/* Goal functions: ************************************************************/

extern GoalType goalBottleOpen(ContentionScheduler *cs);
extern GoalType goalBottleClosed(ContentionScheduler *cs);
extern GoalType goalBottleOpenerHeld(ContentionScheduler *cs);
extern GoalType goalGlassFull(ContentionScheduler *cs);
extern GoalType goalCorkHeld(ContentionScheduler *cs);
extern GoalType goalOpenSourceHeld(ContentionScheduler *cs);
extern GoalType goalCurrentTargetFull(ContentionScheduler *cs);
extern GoalType goalDrinkConsumed(ContentionScheduler *cs);
extern GoalType goalDrinkConsumedAndGlassOnTable(ContentionScheduler *cs);
extern GoalType goalUsedBottleClosed(ContentionScheduler *cs);
extern GoalType goalCorkHeldAndBottleFixated(ContentionScheduler *cs);
extern GoalType goalBottleOpenAndOpenerOnTable(ContentionScheduler *cs);

/******************************************************************************/
/* Object functions: **********************************************************/

extern double isBottle(Object *o);
extern double isFullBottle(Object *o);
extern double isFullContainer(Object *o);
extern double isOpenBottle(Object *o);
extern double isOpenSource(Object *o);
extern double isClosedBottle(Object *o);
extern double isBottleOpener(Object *o);
extern double isCork(Object *o);
extern double isGlass(Object *o);
extern double isEmptyGlass(Object *o);
extern double isFullGlass(Object *o);
extern double isConsumed(Object *o);

/******************************************************************************/

#endif

