/*******************************************************************************

    FILE: candle/effector.c
    AUTHOR: R. Cooper
    CREATION DATE: Tue Aug  3 13:42:44 2004
    CONTENTS: Effector-related routines for the candle task

*******************************************************************************/

#include "../cs.h"

/******************************************************************************/

void write_candle_effector_attributes(FILE *fp, Effector *effector)
{
    ObjectList *os;

    if (effector->itemsHeld) {
	fprintf(fp, "holds");
	for (os = effector->itemsHeld; os; os = os->tail) {
	    if (os->tail) {
		fprintf(fp, " %s,", os->head->name);
	    }
	    else {
		fprintf(fp, " %s", os->head->name);
	    }
	}
    }
    else {
	fprintf(fp, "empty");
    }
}

/******************************************************************************/

void install_candle_effectors(ContentionScheduler *cs)
{
    effectorInstall(cs, "leftHand");
    effectorInstall(cs, "rightHand");
}

/******************************************************************************/
