#ifndef _candle_configure_h

#define _candle_configure_h

#include "../generic.h"

extern double schemaCandleTaskTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaCandleTaskTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaCandleTaskTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaCandleTaskTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaCandleTaskTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaLightMatchTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaLightMatchTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaLightMatchTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaLightCandleTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaLightCandleTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaLightCandleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaInstallCandleTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaInstallCandleTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaInstallCandleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaExtinguishMatchTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaExtinguishMatchTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPlaceCandleInStickTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPlaceCandleInStickTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPlaceCandleInStickTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaInsertCandleTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaInsertCandleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaOpenSourceBoxTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaOpenSourceBoxTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCloseSourceBoxTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaCloseSourceBoxTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaOpenContainerBySlidingTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaOpenContainerBySlidingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaOpenContainerByPeelingTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaOpenContainerByPeelingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaOpenContainerByTearingTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaOpenContainerByTearingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCloseContainerBySlidingTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaCloseContainerBySlidingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaStrikeMatchTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaStrikeMatchTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaStrikeMatchTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaStrikeTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaStrikeTargetTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaStrikeTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaMatchToCandleTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaMatchToCandleTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaMatchToCandleTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaBlowOutFlameTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaBlowOutFlameTriggersEffector(ContentionScheduler *cs, Effector *e);

/******************************************************************************/
/* Goal functions: ************************************************************/

extern GoalType goalMatchFixated(ContentionScheduler *cs);
extern GoalType goalLitMatchFixated(ContentionScheduler *cs);
extern GoalType goalLitObjectFixated(ContentionScheduler *cs);
extern GoalType goalFixatedObjectExtinguished(ContentionScheduler *cs);
extern GoalType goalExtinguishedObjectOnTable(ContentionScheduler *cs);
extern GoalType goalMatchLit(ContentionScheduler *cs);
extern GoalType goalMatchHeld(ContentionScheduler *cs);
extern GoalType goalMatchExtinguished(ContentionScheduler *cs);
extern GoalType goalMatchBoxHeld(ContentionScheduler *cs);
extern GoalType goalMatchBoxFixated(ContentionScheduler *cs);
extern GoalType goalMatchBoxOpen(ContentionScheduler *cs);
extern GoalType goalMatchBoxClosed(ContentionScheduler *cs);
extern GoalType goalCandleFixated(ContentionScheduler *cs);
extern GoalType goalCandleLit(ContentionScheduler *cs);
extern GoalType goalCandleHeld(ContentionScheduler *cs);
extern GoalType goalCandleInstalled(ContentionScheduler *cs);
extern GoalType goalCandleStickFixated(ContentionScheduler *cs);
extern GoalType goalCandleHeldAndStickFixated(ContentionScheduler *cs);
extern GoalType goalExtinguishedMatchOnTable(ContentionScheduler *cs);
extern GoalType goalMatchHeldAndMatchBoxClosed(ContentionScheduler *cs);
extern GoalType goalMatchLitAndMatchBoxOnTable(ContentionScheduler *cs);
extern GoalType goalCandleLitAndExtinguishedMatchOnTable(ContentionScheduler *cs);

/******************************************************************************/
/* Object functions: **********************************************************/

extern double isMatch(Object *o);
extern double isMatchBase(Object *o);
extern double isMatchHead(Object *o);
extern double isMatchBox(Object *o);
extern double isMatchBoxDrawer(Object *o);
extern double isOpenMatchBox(Object *o);
extern double isClosedMatchBox(Object *o);
extern double isCandle(Object *o);
extern double isCandleBase(Object *o);
extern double isCandleTop(Object *o);
extern double isCandleStick(Object *o);
extern double isUsedMatch(Object *o);
extern double isLit(Object *o);
extern double isLitMatch(Object *o);
extern double isFullCandleStick(Object *o);
extern double isLitCandle(Object *o);

/******************************************************************************/

#endif

