/*******************************************************************************

    FILE: candle/triggers.c
    AUTHOR: R. Cooper
    CREATION DATE: Tue Aug  3 13:46:39 2004
    CONTENTS: Schema triggering functions for the candle task

*******************************************************************************/

#include "../cs.h"
#include "task.h"

/******************************************************************************/

extern double holds(Effector *e, double f(Object *object));

/******************************************************************************/

double schemaCandleTaskTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(0);
}

double schemaCandleTaskTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(0);
}

double schemaCandleTaskTriggersTheme(ContentionScheduler *cs, Object *o)
{
    return(0);
}

double schemaCandleTaskTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(0);
}

double schemaCandleTaskTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaLightMatchTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isMatchBox(o));
}

double schemaLightMatchTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isMatchBase(o));
}

double schemaLightMatchTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaLightCandleTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isCandleTop(o));
}

double schemaLightCandleTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isMatch(o));
}

double schemaLightCandleTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaInstallCandleTriggersTheme(ContentionScheduler *cs, Object *o)
{
    return(isCandleBase(o));
}

double schemaInstallCandleTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isCandleStick(o));
}

double schemaInstallCandleTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaExtinguishMatchTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isLitMatch(o));
}

double schemaExtinguishMatchTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaInsertCandleTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isCandleStick(o));
}

double schemaInsertCandleTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaPlaceCandleInStickTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isCandleStick(o));
}

double schemaPlaceCandleInStickTriggersTheme(ContentionScheduler *cs, Object *o)
{
    return(isCandleBase(o));
}

double schemaPlaceCandleInStickTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaOpenSourceBoxTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isMatchBox(o));
}

double schemaOpenSourceBoxTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaCloseSourceBoxTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isMatchBox(o));
}

double schemaCloseSourceBoxTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaOpenContainerBySlidingTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isMatchBox(o));
}

double schemaOpenContainerBySlidingTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(isFullEffectorFuzzy(e));
}

/******************************************************************************/

double schemaOpenContainerByPeelingTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isContainer(o) / 2.0);
}

double schemaOpenContainerByPeelingTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(isFullEffectorFuzzy(e));
}

/******************************************************************************/

double schemaOpenContainerByTearingTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isContainer(o) / 2.0);
}

double schemaOpenContainerByTearingTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(isFullEffectorFuzzy(e));
}

/******************************************************************************/

double schemaCloseContainerBySlidingTriggersSource(ContentionScheduler *cs, Object *o)
{
    return(isMatchBox(o));
}

double schemaCloseContainerBySlidingTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/******************************************************************************/

double schemaStrikeMatchTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isMatchBox(o));
}

double schemaStrikeMatchTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isMatchHead(o));
}

double schemaStrikeMatchTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isMatch));
}

/******************************************************************************/

double schemaStrikeTargetTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(1.0);
}

double schemaStrikeTargetTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isTool(o));
}

double schemaStrikeTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isTool));
}

/******************************************************************************/

double schemaMatchToCandleTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(isCandleTop(o));
}

double schemaMatchToCandleTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isMatchHead(o));
}

double schemaMatchToCandleTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isMatch));
}

/******************************************************************************/

double schemaBlowOutFlameTriggersImplement(ContentionScheduler *cs, Object *o)
{
    return(isLit(o));
}

double schemaBlowOutFlameTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isLit));
}

/******************************************************************************/
