#ifndef _espresso_configure_h

#define _espresso_configure_h

#include "../generic.h"

extern double schemaPrepareEspressoTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaFillEspressoBaseTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPositionEspressoFilterTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaAddGroundsToFilterTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPositionEspressoFilterTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaAssembleEspressoTopTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaCoverTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPourSomeTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaEmptyScoopTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaScrewPotClosedTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaScrewPotOpenTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaHoldBaseTriggersTarget(ContentionScheduler *cs, Object *o);

extern double schemaPrepareEspressoTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaFillEspressoBaseTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaAddGroundsToFilterTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaScoopTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPourSomeTriggersSource(ContentionScheduler *cs, Object *o);

extern double schemaPrepareEspressoTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaAddGroundsToFilterTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaScoopTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaEmptyScoopTriggersImplement(ContentionScheduler *cs, Object *o);

extern double schemaPrepareEspressoTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPositionEspressoFilterTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaAssembleEspressoTopTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaCoverTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaScrewPotClosedTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaScrewPotOpenTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaHoldTopTriggersTheme(ContentionScheduler *cs, Object *o);

extern double schemaPrepareEspressoTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaFillEspressoBaseTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaAssembleEspressoFilterTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaPositionEspressoFilterTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaAddGroundsToFilterTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaPositionEspressoFilterTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaAssembleEspressoTopTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaCoverTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaScoopTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaPourSomeTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaEmptyScoopTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaScrewPotClosedTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaScrewPotOpenTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaHoldBaseTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaHoldTopTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPourSomeIntoTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPourSomeIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCoverTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaCoverTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaDipScoopIntoSourceTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaDipScoopIntoSourceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaEmptyScoopIntoTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaEmptyScoopIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

/******************************************************************************/
/* Goal functions: ************************************************************/

extern GoalType goalEspressoBaseFilled(ContentionScheduler *cs);
extern GoalType goalEspressoFilterPositioned(ContentionScheduler *cs);
extern GoalType goalEspressoFilterAssembled(ContentionScheduler *cs);
extern GoalType goalEspressoFilterFull(ContentionScheduler *cs);
extern GoalType goalEspressoPotAssembled(ContentionScheduler *cs);
extern GoalType goalAssembledEspressoPotOnTable(ContentionScheduler *cs);
extern GoalType goalHoldFullJug(ContentionScheduler *cs);
extern GoalType goalHoldEspressoFilter(ContentionScheduler *cs);
extern GoalType goalHoldEspressoTop(ContentionScheduler *cs);
extern GoalType goalHoldEspressoBase(ContentionScheduler *cs);
extern GoalType goalHoldEspressoBaseAndTop(ContentionScheduler *cs);
extern GoalType goalHoldEspressoImplement(ContentionScheduler *cs);
extern GoalType goalHoldFullImplement(ContentionScheduler *cs);
extern GoalType goalHoldEmptyImplement(ContentionScheduler *cs);
extern GoalType goalImplementNotHeld(ContentionScheduler *cs);
extern GoalType goalJugOnTableAndEspressoBaseFull(ContentionScheduler *cs);
extern GoalType goalEmptyContainerHeld(ContentionScheduler *cs);
extern GoalType goalCurrentTargetFull(ContentionScheduler *cs);
extern GoalType goalCurrentTargetCovered(ContentionScheduler *cs);

extern GoalType goalEmptyScoopHeld(ContentionScheduler *cs);
extern GoalType goalSourceFixated(ContentionScheduler *cs);
extern GoalType goalTargetFixated(ContentionScheduler *cs);
extern GoalType goalThemeFixated(ContentionScheduler *cs);
extern GoalType goalImplementFixated(ContentionScheduler *cs);
extern GoalType goalEspressoTopFixated(ContentionScheduler *cs);
extern GoalType goalEspressoBaseFixated(ContentionScheduler *cs);
extern GoalType goalHoldFullJugAndTargetFixated(ContentionScheduler *cs);
extern GoalType goalHoldEspressoFilterAndTargetFixated(ContentionScheduler *cs);
extern GoalType goalHoldEspressoImplementAndSourceFixated(ContentionScheduler *cs);
extern GoalType goalHoldFullImplementAndTargetFixated(ContentionScheduler *cs);

/******************************************************************************/
/* Object functions: **********************************************************/

extern double isEspressoTop(Object *o);
extern double isEspressoBase(Object *o);
extern double isEspressoFilter(Object *o);
extern double isAssembledEspressoPot(Object *o);
extern double isJug(Object *o);
extern double isSpoon(Object *o);
extern double isCoffeePacket(Object *o);
extern double isFullJug(Object *o);
extern double isFullContainer(Object *o);
extern double isOpenContainer(Object *o);
extern double isFullImplement(Object *o);
extern double isEmptyImplement(Object *o);

/******************************************************************************/

#endif
