#include "../cs.h"
#include "task.h"

double holds(Effector *e, double f(Object *o));

/******************************************************************************/

double schemaPrepareEspressoTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(0);
}

double schemaPrepareEspressoTriggersSource(ContentionScheduler *cs, Object *object)
{
    return(0);
}

double schemaPrepareEspressoTriggersImplement(ContentionScheduler *cs, Object *object)
{
    return(0);
}

double schemaPrepareEspressoTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(0);
}

/*----------------------------------------------------------------------------*/

double schemaFillEspressoBaseTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isEspressoBase(object), isOpen(object)));
}

double schemaFillEspressoBaseTriggersSource(ContentionScheduler *cs, Object *object)
{
   return(isFullJug(object));
}

/*----------------------------------------------------------------------------*/

double schemaPositionEspressoFilterTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isEspressoBase(object), isOpen(object)));
}

double schemaPositionEspressoFilterTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isEspressoFilter(object));
}

/*----------------------------------------------------------------------------*/

double schemaAddGroundsToFilterTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEspressoFilter(object));
}

double schemaAddGroundsToFilterTriggersSource(ContentionScheduler *cs, Object *object)
{
   return(isCoffeePacket(object));
}

double schemaAddGroundsToFilterTriggersImplement(ContentionScheduler *cs, Object *object)
{
    return(isSpoon(object));
}

/*----------------------------------------------------------------------------*/

double schemaAssembleEspressoTopTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEspressoBase(object));
}

double schemaAssembleEspressoTopTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isEspressoTop(object));
}

/*----------------------------------------------------------------------------*/

double schemaHoldBaseTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEspressoBase(object));
}

/*----------------------------------------------------------------------------*/

double schemaHoldTopTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isEspressoTop(object));
}

/*----------------------------------------------------------------------------*/

double schemaPourSomeIntoTargetTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(FZOR(isEspressoBase(object), isTable(object)));
}

double schemaPourSomeIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

/* Lowest level: -------------------------------------------------------------*/

double schemaCoverTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(FZAND(isEspressoBase(object), isOpen(object)));
}

double schemaCoverTriggersTheme(ContentionScheduler *cs, Object *object)
{
   return(isEspressoFilter(object));
}

double schemaScoopTriggersSource(ContentionScheduler *cs, Object *object)
{
   return(isCoffeePacket(object));
}

double schemaScoopTriggersImplement(ContentionScheduler *cs, Object *object)
{
   return(isSpoon(object));
}

double schemaEmptyScoopTriggersTarget(ContentionScheduler *cs, Object *object)
{
   return(isOpenContainer(object));
}

double schemaEmptyScoopTriggersImplement(ContentionScheduler *cs, Object *object)
{
   return(FZAND(isOpenContainer(object), FZAND(isFullObject(object), isHeld(object))));
}

double schemaScrewPotClosedTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isEspressoBase(object));
}

double schemaScrewPotClosedTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isEspressoTop(object));
}

double schemaScrewPotOpenTriggersTarget(ContentionScheduler *cs, Object *object)
{
    return(isAssembledEspressoPot(object));
}

double schemaScrewPotOpenTriggersTheme(ContentionScheduler *cs, Object *object)
{
    return(isEspressoTop(object));
}

/******************************************************************************/

double schemaCoverTargetTriggersTarget(ContentionScheduler *cs, Object *o)
{
    return(FZAND(isContainer(o), isOpen(o)));
}

double schemaCoverTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(isFullEffectorFuzzy(e));
}

/******************************************************************************/

double schemaDipScoopIntoSourceTriggersSource(ContentionScheduler *cs, Object *o)
{
   return(FZAND(isFullContainer(o), isOpen(o)));
}

double schemaDipScoopIntoSourceTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isTool));
}

/******************************************************************************/

double schemaEmptyScoopIntoTargetTriggersTarget(ContentionScheduler *cs, Object *o)
{
   return(FZAND(isContainer(o), isOpen(o)));
}

double schemaEmptyScoopIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isTool));
}

/******************************************************************************/
/* High level effector triggers: ---------------------------------------------*/

double schemaPrepareEspressoTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaFillEspressoBaseTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaAssembleEspressoFilterTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaPositionEspressoFilterTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaAddGroundsToFilterTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(restAct);
}

double schemaAssembleEspressoTopTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(FZOR(holds(e, isEspressoBase), holds(e, isEspressoTop)));
}

double schemaHoldBaseTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEspressoBase));
}

double schemaHoldTopTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEspressoTop));
}

/* Lowest level effector triggers: -------------------------------------------*/

double schemaCoverTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isEspressoFilter));
}

double schemaScoopTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isTool));
}

double schemaEmptyScoopTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isFullImplement));
}

double schemaScrewPotClosedTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(FZOR(holds(e, isEspressoBase), holds(e, isEspressoTop)));
}

double schemaScrewPotOpenTriggersEffector(ContentionScheduler *cs, Effector *e)
{
    return(holds(e, isAssembledEspressoPot));
}

/******************************************************************************/
