/******************************************************************************/

#ifndef Boolean
#define Boolean int
#define TRUE 1
#define FALSE 0
#endif

#include "file_misc.h"
#include <sys/stat.h>

/******************************************************************************/

Boolean file_exists(char *filename)
{
    struct stat st;

    return( stat(filename, &st) == 0 );
}

Boolean is_directory(char *filename)
{
    struct stat st;

    if (stat(filename, &st) == 0) {
        return((st.st_mode & S_IFMT) == S_IFDIR);
    }
    else {
        return(FALSE);
    }
}

Boolean make_directory(char *directory)
{
    if (!is_directory(directory)) {
        if (file_exists(directory)) {
            return(FALSE);
        }
        else if (mkdir(directory, S_IRWXU | S_IRWXG | S_IRWXO) == 0) {
            return(TRUE);
        }
        else {
            return(FALSE);
        }
    }
    else {
        return(TRUE);
    }
}

/******************************************************************************/


