#ifndef _juice_configure_h

#define _juice_configure_h

#include "../generic.h"

extern double schemaPrepareJuiceTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPrepareJuiceTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPrepareJuiceTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPrepareJuiceTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaPrepareJuiceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCutOrangeTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaCutOrangeTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaCutOrangeTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaJuiceOrangeWithJuicerTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaJuiceOrangeWithJuicerTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaJuiceOrangeWithJuicerTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaJuiceOrangeByHandTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaJuiceOrangeByHandTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaJuiceOrangeByHandTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFillGlassTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaFillGlassTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaFillGlassTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCutBySawingTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaCutBySawingTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaCutBySawingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCutByPushingTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaCutByPushingTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaCutByPushingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPourAllTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaPourAllTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPourAllTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaSqueezeByTwistingTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeByTwistingTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeByTwistingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaSqueezeByPushingTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeByPushingTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeByPushingTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaSqueezeByHandTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeByHandTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeByHandTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaBounceBallTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaBounceBallTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaBounceBallTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaSqueezeOverGlassTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeOverGlassTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaCutThemeTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaCutThemeTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaSqueezeWithImplementTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaSqueezeWithImplementTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaPourAllIntoTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPourAllIntoTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaBounceOnTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaBounceOnTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaBounceTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaBounceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaDrinkJuiceTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaDrinkJuiceTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaDrinkTriggersSource(ContentionScheduler *cs, Object *o);
extern double schemaDrinkTriggersEffector(ContentionScheduler *cs, Effector *e);

/******************************************************************************/
/* Goal functions: ************************************************************/

extern GoalType goalOrangeCut(ContentionScheduler *cs);
extern GoalType goalOrangeJuiced(ContentionScheduler *cs);
extern GoalType goalOrangeCutAndHandsEmpty(ContentionScheduler *cs);
extern GoalType goalOrangeJuicedAndHandsEmpty(ContentionScheduler *cs);
extern GoalType goalCurrentThemeCut(ContentionScheduler *cs);
extern GoalType goalJuicerFull(ContentionScheduler *cs);
extern GoalType goalJuicerEmptyAndJuiceGlassFull(ContentionScheduler *cs);
extern GoalType goalKnifeFixated(ContentionScheduler *cs);
extern GoalType goalKnifeHeld(ContentionScheduler *cs);
extern GoalType goalKnifeHeldAndOrangeFixated(ContentionScheduler *cs);
extern GoalType goalOrangeCutAndKnifeOnTable(ContentionScheduler *cs);

extern GoalType goalOrangePieceFixated(ContentionScheduler *cs);
extern GoalType goalOrangePieceHeld(ContentionScheduler *cs);
extern GoalType goalOrangePieceHeldAndJuicerFixated(ContentionScheduler *cs);
extern GoalType goalOrangePieceJuicedAndNotHeld(ContentionScheduler *cs);
extern GoalType goalJuicedOrangePieceHeld(ContentionScheduler *cs);

extern GoalType goalJuicerFixated(ContentionScheduler *cs);
extern GoalType goalJuicerHeld(ContentionScheduler *cs);
extern GoalType goalEmptyJuicerHeld(ContentionScheduler *cs);
extern GoalType goalEmptyContainerHeld(ContentionScheduler *cs);
extern GoalType goalFullJuicerHeld(ContentionScheduler *cs);
extern GoalType goalFullJuicerHeldAndJuiceGlassFixated(ContentionScheduler *cs);
extern GoalType goalEmptyJuicerOnTable(ContentionScheduler *cs);
extern GoalType goalFullJuiceGlassHeld(ContentionScheduler *cs);
extern GoalType goalFullJuiceGlassOnTable(ContentionScheduler *cs);
extern GoalType goalEmptyJuicerOnTableAndJuiceGlassFull(ContentionScheduler *cs);

extern GoalType goalBallFixated(ContentionScheduler *cs);
extern GoalType goalBallHeld(ContentionScheduler *cs);
extern GoalType goalBallHeldAndTargetFixated(ContentionScheduler *cs);
extern GoalType goalBallBounced(ContentionScheduler *cs);
extern GoalType goalBouncedBallOnTable(ContentionScheduler *cs);

extern GoalType goalJuiceConsumed(ContentionScheduler *cs);
extern GoalType goalJuiceConsumedAndSourceOnTable(ContentionScheduler *cs);

/******************************************************************************/
/* Object functions: **********************************************************/

extern double isKnife(Object *o);
extern double isKnifeBlade(Object *o);
extern double isKnifeHandle(Object *o);
extern double isOrange(Object *o);
extern double isOrangePiece(Object *o);
extern double isJuicedOrangePiece(Object *o);
extern double isJuiceGlass(Object *o);
extern double isEmptyJuiceGlass(Object *o);
extern double isFullJuiceGlass(Object *o);
extern double isJuicer(Object *o);
extern double isEmptyJuicer(Object *o);
extern double isFullJuicer(Object *o);
extern double isSqueezed(Object *o);
extern double isCut(Object *o);
extern double isSoft(Object *o);
extern double isFirm(Object *o);

/******************************************************************************/

#endif

