#ifndef _letter_configure_h

#define _letter_configure_h

#include "../generic.h"

extern double schemaPrepareLetterTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaAddressEnvelopeTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaApplyStampTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaInsertLetterTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPlaceStampTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaWriteAddressTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaPackEnvelopeTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaSealItTriggersTarget(ContentionScheduler *cs, Object *o);

extern double schemaPrepareLetterTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaApplyStampTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPlaceStampTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaInsertLetterTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaSealEnvelopeTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaPackEnvelopeTriggersTheme(ContentionScheduler *cs, Object *o);

extern double schemaPrepareLetterTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaAddressEnvelopeTriggersImplement(ContentionScheduler *cs, Object *o);
extern double schemaWriteAddressTriggersImplement(ContentionScheduler *cs, Object *o);

extern double schemaAddressEnvelopeTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaPrepareLetterTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaApplyStampTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaInsertLetterTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaSealEnvelopeTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaPlaceStampTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaWriteAddressTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaPackEnvelopeTriggersEffector(ContentionScheduler *cs, Effector *e);
extern double schemaSealItTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaLickTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaLickTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaAddressTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaAddressTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaStampTargetTriggersTarget(ContentionScheduler *cs, Object *o);
extern double schemaStampTargetTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFoldLetterTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaFoldLetterTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaLickAndSealTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaLickAndSealTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaTuckFlapTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaTuckFlapTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaFoldTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaFoldTriggersEffector(ContentionScheduler *cs, Effector *e);

extern double schemaTuckTriggersTheme(ContentionScheduler *cs, Object *o);
extern double schemaTuckTriggersEffector(ContentionScheduler *cs, Effector *e);

/******************************************************************************/
/* Goal functions: ************************************************************/

extern GoalType goalCurrentTargetAddressed(ContentionScheduler *cs);

extern GoalType goalTargetAddressed(ContentionScheduler *cs);
extern GoalType goalEnvelopeStuffed(ContentionScheduler *cs);
extern GoalType goalEnvelopeLicked(ContentionScheduler *cs);
extern GoalType goalEnvelopeOnTable(ContentionScheduler *cs);
extern GoalType goalEnvelopeSealed(ContentionScheduler *cs);
extern GoalType goalTargetAddressedAndPenOnTable(ContentionScheduler *cs);
extern GoalType goalSealedEnvelopeOnTable(ContentionScheduler *cs);
extern GoalType goalStuffedEnvelopeOnTable(ContentionScheduler *cs);

extern GoalType goalEnvelopeHeld(ContentionScheduler *cs);
extern GoalType goalLetterHeld(ContentionScheduler *cs);
extern GoalType goalPenHeld(ContentionScheduler *cs);
extern GoalType goalStampHeld(ContentionScheduler *cs);
extern GoalType goalStampApplied(ContentionScheduler *cs);
extern GoalType goalLetterHeldAndEnvelopeHeld(ContentionScheduler *cs);

extern GoalType goalFoldedLetterOnTable(ContentionScheduler *cs);

extern GoalType goalLetterFolded(ContentionScheduler *cs);
extern GoalType goalLetterFoldedAndEnvelopeHeld(ContentionScheduler *cs);
extern GoalType goalPenOnTable(ContentionScheduler *cs);
extern GoalType goalStampLicked(ContentionScheduler *cs);

extern GoalType goalLetterFixated(ContentionScheduler *cs);
extern GoalType goalPenFixated(ContentionScheduler *cs);
extern GoalType goalStampFixated(ContentionScheduler *cs);

extern GoalType goalStampLickedAndStampTargetFixated(ContentionScheduler *cs);
extern GoalType goalLetterFoldedAndEnvelopeFixated(ContentionScheduler *cs);

/******************************************************************************/
/* Object functions: **********************************************************/

extern double isStamp(Object *o);
extern double isEnvelope(Object *o);
extern double isStampFront(Object *o);
extern double isEnvelopeFront(Object *o);
extern double isStampBack(Object *o);
extern double isEnvelopeBack(Object *o);
extern double isLetter(Object *o);
extern double isUnsealedEnvelope(Object *o);
extern double isEnvelopeBackOrStampBack(Object *o);
extern double isPaper(Object *o);
extern double isPen(Object *o);
extern double isPenNib(Object *o);
extern double isPenStalk(Object *o);
extern double isFoldedLetter(Object *o);
extern double isAddressed(Object *o);
extern double isStamped(Object *o);
extern double isFolded(Object *o);
extern double isMoist(Object *o);
extern double isStuffed(Object *o);
extern double isSealed(Object *o);

/******************************************************************************/

#endif

